require 'spec_helper'

describe RouteNGNClient::Connection do

  before do
    bodya = '{"total_count":1,"current_page":1,"per_page":200,"offset":0,"total_pages":1,"testa":[]}'
    stub_request(:get, /^http:\/\/127\.0\.0\.1\/testa\.json.*/).to_return(:body => bodya,
                                                                          :status => 200,
                                                                          :headers => { 'Content-Type' => 'application/json; charset=utf-8' })

    stub_request(:get, /^http:\/\/127\.0\.0\.1\/faila\.json.*/).to_return(:body => bodya,
                                                                          :status => 500,
                                                                          :headers => { 'Content-Type' => 'application/json; charset=utf-8' })
  end

  it "should create a new instance given valid attributes" do
    c = Connection.new
    c.should be_an_instance_of(Connection)
  end

  describe '#create_faraday' do
    it "should return an instace of Faraday::Connection" do
      c = Connection.new
      f = c.create_faraday('http://localhost/test.json')
      f.should be_an_instance_of(Faraday::Connection)
    end
  end

  describe '#request' do
    it "should return an instace of Faraday::Response" do
      c = Connection.new
      f = c.create_faraday('http://127.0.0.1')
      f.send(:get, 'testa.json').should be_an_instance_of(Faraday::Response)
    end

    it "should a bad status code should raise an exception" do
      c = Connection.new
      f = c.create_faraday('http://127.0.0.1')
      expect { f.send(:get, 'faila.json') }.to raise_error
      begin;f.send(:get, 'faila.json');rescue => e; e.should be_an_instance_of(UnexpectedHTTPException);end
    end
  end

end