require 'spec_helper'

describe RouteNGNClient::Account do

  before do
    RouteNGNClient.connect(:uri => 'http://127.0.0.1')
    body = '{"total_count":3,"current_page":1,"per_page":25,"offset":0,"total_pages":1,"accounts":[{"account":{"company":"Call Processor","created_at":"2013-03-04T23:56:44Z","updated_at":"2013-03-04T23:56:44Z","id":"513534bc6f1cc938d5000001","system_admin":true}},{"account":{"company":"Nagios","created_at":"2013-03-04T23:56:45Z","updated_at":"2013-03-04T23:56:45Z","id":"513534bd6f1cc938d5000006","system_admin":false}},{"account":{"company":"testing","created_at":"2013-03-04T23:59:10Z","updated_at":"2013-03-04T23:59:10Z","id":"5135354e6f1cc9a140000004","system_admin":false}}]}'
    stub_request(:get, /^http:\/\/127\.0\.0\.1\/system_admin\/accounts\.json.*/).to_return(:body => body,
                                                                                           :status => 200,
                                                                                           :headers => { 'Content-Type' => 'application/json; charset=utf-8' })
  end

  it "should create a new instance given valid attributes" do
    a = Account.new
    a.should be_an_instance_of(Account)
  end

  describe '#all' do
    it "should return an instace of Array" do      
      accounts = Account.all
      accounts.should be_an_instance_of(Array)
      accounts.length.should == 3
      accounts.first.should be_an_instance_of(Account)
    end
  end

end

