require 'spec_helper'

describe RouteNGNClient::Carrier do

  before do
    RouteNGNClient.connect(:uri => 'http://127.0.0.1')
    body = '{"total_count":2,"current_page":1,"per_page":25,"offset":0,"total_pages":1,"carriers":[{"carrier":{"name":"Carrier A","minimum_duration":null,"billing_increment":null,"color_code":"#f3a679","created_at":"2013-03-05T00:11:29Z","updated_at":"2013-03-05T00:11:29Z","id":"513538316f1cc9a140000011","account_id":"5135354e6f1cc9a140000004"}},{"carrier":{"name":"Carrier B","minimum_duration":null,"billing_increment":null,"color_code":"#f37990","created_at":"2013-03-05T00:12:04Z","updated_at":"2013-03-05T00:12:04Z","id":"513538546f1cc9a140000017","account_id":"5135354e6f1cc9a140000004"}}]}'
    stub_request(:get, /^http:\/\/127\.0\.0\.1\/metallic\/carriers\.json.*/).to_return(:body => body,
                                                                                      :status => 200,
                                                                                      :headers => { 'Content-Type' => 'application/json; charset=utf-8' })
  end

  it "can get all" do  
    RouteNGNClient::Carrier.all({}, :account_id => 'foofoo') do |models|
      models.length.should == 2
      models.first.should be_an_instance_of RouteNGNClient::Carrier
    end
  end

end