require 'spec_helper'

describe RouteNGNClient::Code do

  before do
    RouteNGNClient.connect(:uri => 'http://127.0.0.1')
    body = "{\"total_count\":1,\"current_page\":1,\"per_page\":25,\"offset\":0,\"total_pages\":1,\"codes\":[{\"code\":{\"dialcode\":\"2122226\",\"local\":null,\"city\":\"CAPITAL PENNS\",\"state\":\"PA\",\"country\":null,\"lata\":\"226\",\"ocn\":\"EOCN\",\"ocn_name\":null,\"lerg_category\":null,\"disabled\":null,\"blocked\":null,\"effective_at\":null,\"ineffective_at\":null,\"line_number\":null,\"created_at\":null,\"updated_at\":null,\"id\":\"5066a1e80a516552b9443d23\",\"code_sheet_id\":\"50669c9f4c6b97c82f00003d\"}}]}"
    stub_request(:get, /^http:\/\/127\.0\.0\.1\/metallic\/codes\.json.*/).to_return(:body => body,
                                                                                    :status => 200,
                                                                                    :headers => { 'Content-Type' => 'application/json; charset=utf-8' })
  end

  it "can be instanstiated" do
    c = Code.new
    c.should be_an_instance_of(Code)
  end

  it "can find_by_exploded_dialcode" do
    codes1 = nil
    codes2 = nil

    codes1 = Code.find_by_exploded_dialcode('2122226263')
    codes2 = Code.find_by_dialcodes(['2122226263', '212'])

    codes1.length.should == 1
    codes1.first.should be_an_instance_of(Code)

    codes2.length.should == 1
    codes2.first.should be_an_instance_of(Code)
  end

end