require 'spec_helper'

describe RouteNGNClient::InboundEndPointGroup do

  before do
    RouteNGNClient.connect(:uri => 'http://127.0.0.1')
    body = "{\"total_count\":1,\"current_page\":1,\"per_page\":25,\"offset\":0,\"total_pages\":1,\"inbound_end_point_groups\":[{\"inbound_end_point_group\":{\"name\":\"IEPG 1\",\"contact_template\":\"<sip:${ruri.dialcode}${ruri.user_params}${oepg.uri_user_params}@${oep.host}${oep.port}${ruri.params}${oepg.uri_params}>\",\"multi_line_contacts\":true,\"color_code\":\"#a4f379\",\"route_on_type\":\"DN\",\"min_percent_price_margin\":null,\"min_absolute_price_margin\":null,\"min_route_weight\":null,\"dialcode_expression\":\"([0-9]*)$\",\"dialcode_prefix_expression\":\"^(.*D+)\",\"ani_expression\":\"([0-9]*)$\",\"ani_prefix_expression\":\"^(.*D+)\",\"destination_billing_type\":\"DN\",\"external_lrn_lookup_enabled\":false,\"created_at\":\"2013-03-05T00:11:29Z\",\"updated_at\":\"2013-03-05T00:35:24Z\",\"id\":\"513538316f1cc9a140000010\",\"carrier_id\":\"513538316f1cc9a140000011\",\"primary_route_table_id\":\"513538666f1cc9a14000001b\",\"secondary_route_table_id\":\"\",\"allow_list\":{\"id\":\"513538316f1cc9a14000000e\",\"uri_matchers\":[{\"header\":\"request\",\"prefix\":\"\",\"user_params\":\"tgrp=foo\",\"uri_params\":\"\",\"created_at\":\"2013-03-05T00:11:29Z\",\"updated_at\":\"2013-03-05T00:11:29Z\",\"id\":\"513538316f1cc9a14000000f\"}]},\"end_points\":[{\"end_point\":{\"host\":\"127.0.0.1\",\"port\":5060,\"priority\":null,\"created_at\":null,\"updated_at\":null,\"id\":\"51353dcc6f1cc9f910000006\"}}]}}]}"
    stub_request(:get, /^http:\/\/127\.0\.0\.1\/metallic\/inbound_end_point_groups\.json.*/).to_return(:body => body,
                                                                                                       :status => 200,
                                                                                                       :headers => { 'Content-Type' => 'application/json; charset=utf-8' })
  end

  it "can get all via callback" do
    iepgs = nil

    RouteNGNClient::InboundEndPointGroup.all({}, :account_id => 'foofoo') do |models|
      iepgs = models
    end

    iepgs.length.should == 1
    iepgs.first.should be_an_instance_of RouteNGNClient::InboundEndPointGroup
  end

  it "can get all via fibers" do
    iepgs = nil

    iepgs = RouteNGNClient::InboundEndPointGroup.all({}, :account_id => 'foofoo')

    iepgs.length.should == 1
    iepgs.first.should be_an_instance_of RouteNGNClient::InboundEndPointGroup
  end

end