require 'spec_helper'

describe RouteNGNClient::Record do

  let(:iepg1) {
    InboundEndPointGroup.new({ "name"=>"IEPG 1",
                               "contact_template"=>"<sip:${ruri.dialcode}${ruri.user_params}${oepg.uri_user_params}@${oep.host}${oep.port}${ruri.params}${oepg.uri_params}>",
                               "multi_line_contacts"=>true,
                               "color_code"=>"#a4f379",
                               "route_on_type"=>"DN",
                               "min_percent_price_margin"=>nil,
                               "min_absolute_price_margin"=>nil,
                               "min_route_weight"=>nil,
                               "dialcode_expression"=>"([0-9]*)$",
                               "dialcode_prefix_expression"=>"^(.*D+)",
                               "ani_expression"=>"([0-9]*)$",
                               "ani_prefix_expression"=>"^(.*D+)",
                               "destination_billing_type"=>"DN",
                               "external_lrn_lookup_enabled"=>false,
                               "created_at"=>"2013-03-05T00:11:29Z",
                               "updated_at"=>"2013-03-05T00:35:24Z",
                               "id"=>"513538316f1cc9a140000010",
                               "carrier_id"=>"513538316f1cc9a140000011",
                               "primary_route_table_id"=>"513538666f1cc9a14000001b",
                               "secondary_route_table_id"=>"",
                               "allow_list" => {"id"=>"513538316f1cc9a14000000e",
                                 "uri_matchers" => [{"header"=>"request",
                                                    "prefix"=>"",
                                                    "user_params"=>"tgrp=foo",
                                                    "uri_params"=>"",
                                                    "created_at"=>"2013-03-05T00:11:29Z",
                                                    "updated_at"=>"2013-03-05T00:11:29Z",
                                                    "id"=>"513538316f1cc9a14000000f"}]},
                               "end_points"=> [{"end_point"=> {"host"=>"127.0.0.1",
                                                               "port"=>5060,
                                                               "priority"=>nil,
                                                               "created_at"=>nil,
                                                               "updated_at"=>nil,
                                                               "id"=>"51353dcc6f1cc9f910000006"}}]
                              })
  }

  it "can be instanstiated" do
    r = Record.new
    r.should be_an_instance_of(Record)
  end

  it "can be json serialized" do
    r = Record.new
    r.set_inbound_end_point_group iepg1
    r.inbound_end_point_group.should be_an_instance_of(InboundEndPointGroup)
    j = r.to_json
    j.should be_an_instance_of(String)
    r2 = Record.from_json j
    r2.should be_an_instance_of(Record)
    r2.inbound_end_point_group.should be_an_instance_of(InboundEndPointGroup)
  end

end