require 'spec_helper'

describe RouteNGNClient::Response do

  before do
    @env1 = { :status => 200,
              :body => {
                        :total_count => 1,
                        :current_page => 1,
                        :per_page => 10,
                        :offset => 0,
                        :total_pages => 1
                      }
               }
  end

  it "should create a new instance given valid attributes" do
    c = Response.new(nil, nil)
    c.should be_an_instance_of(Response)
  end

  it "should have paging information" do
    fr = OpenStruct.new(:env => @env1)
    r = Response.new(nil, fr)
    r.total_pages.should == 1    
    r.pages_left?.should == false
  end

end